<?php

namespace Teknisa\PLA\Modules\Medicao\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class SobraLimpaReportController extends \Zeedhi\Framework\Controller\Report {

	protected $plaUtil;
	protected $birtStrategy;
	protected $environment;
	protected $reportService;
	protected $reportMapping = array (
        'PLA01200' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'NRLISTAFILISERV' => 'P_NRLISTAFILISERV',
                'DTINICIAL'       => 'P_DTINICIAL',
                'DTFINAL'         => 'P_DTFINAL',
                'NRORG'           => 'P_NRORG',
            ),
        ),
        'PLA01201' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
				'NRLISTAFILISERV' => 'P_NRLISTAFILISERV',
                'DTINICIAL'       => 'P_DTINICIAL',
                'DTFINAL'         => 'P_DTFINAL',
                'NRORG'           => 'P_NRORG',
            ),
        ),
		'PLA01202' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'DTINICIAL'       => 'P_DTINICIAL',
                'DTFINAL'         => 'P_DTFINAL',
				'NRLISTAFILISERV' => 'P_NRLISTAFILISERV',
                'NRORG'           => 'P_NRORG',
            ),
        ),
        'PLA01203' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'NRTIPOCUSTO'     => 'P_NRTIPOCUSTO',
                'NMTIPOCUSTO'     => 'P_NMTIPOCUSTO',
                'DTINICIAL'       => 'P_DTINICIAL',
                'DTFINAL'         => 'P_DTFINAL',
				'NRLISTAFILISERV' => 'P_NRLISTAFILISERV',
                'NRORG'           => 'P_NRORG',
            ),
        )
    );

	public function __construct($reportService, $plaUtil, $birtStrategy, $environment) {
        $this->plaUtil = $plaUtil;
        $this->birtStrategy = $birtStrategy;
        $this->environment = $environment;
        $this->reportService = $reportService;
    }

	public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
		$row = $request->getRow();
    	$this->birtStrategy->setReportFormat(strtolower($row['REPORT_FORMAT']));
		if(isset($row['CDTIPOCUSTO'])){
		    $row['NRTIPOCUSTO'] = floatval($row['CDTIPOCUSTO']);
        }  
		if($row['ALL_SERVICES'] == 'S' && $row['ALL_UNITS'] == 'S'){
			$row['NRLISTAFILISERV'] = 'T';	
		} else {
			$row['NRLISTAFILISERV'] = $this->plaUtil->criarListaValores(implode('_', $row['FILISERV']));
		}
		$row['NRORG'] = $this->environment->getNrOrg();
	}

}